/**
 * 
 */
package org.vamsas.client;
/**
 * Base class for all Vamsas objects extracted 
 * from an IClientDocument. 
 * An object maybe registered or unregistered.
 * 
 * @author jimp
 *
 */
public abstract class object {

    /**
     * unique id for all vamsas objects
     * allows unambiguous referencing
     * to any object in the vamsas document
     */
  	protected boolean __stored_in_document=false;
    protected VorbaId __vorba__id=null;
    protected IVorbaIdFactory __vorba=null;
    /**
     * 
     * @return true if object is registered
     */
    public boolean isRegistered() {
      return (__vorba__id!=null);
    }
    /**
     * Method to get fixed reference for
     * the object in the vamsas document.
     * @returns null if object is neither registered 
     * or not associated with a properly instantiated 
     * VorbaIdFactory.
     */
    public String getId() {
      if (__vorba__id==null) {
        // Try to use the associated factory.
        if (__vorba!=null) 
          if ((__vorba__id = __vorba.makeVorbaId())==null)
            return null; // Factory not valid.
        else
          return null;
      }
      return __vorba__id.getId();
    }
    /**
     * used by the IClient implementation
     * to generate unique Id based on
     * client applications current namespace.
     */
    protected void setVorbaId(VorbaId newid) {
      __vorba__id = newid;
    }
    
    /**
     * @return true if object is present in Vamsas Document.
     */
    public boolean is__stored_in_document() {
      return __stored_in_document;
    }
    /**
     * for use by Vorba agent to reflect state of 
     * vamsas object to client application.
     * @param __stored_in_document The __stored_in_document to set.
     */
    protected void set__stored_in_document(boolean __stored_in_document) {
      this.__stored_in_document = __stored_in_document;
    }
}
